<?php
/***********************************************************************

  Copyright (C) 2002, 2003, 2004  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


$pun_root = './';
require $pun_root.'include/common.php';


if ($cookie['is_guest'] && $pun_config['p_guests_read'] == '0')
	message($lang_common['Login required']);


// Load the help.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_help.php';

// Determine what style to use (for the [img] example)
if ($cur_user['style'] != '' && @file_exists($pun_root.'style/'.$cur_user['style'].'.css'))
	$img_url = $pun_config['o_base_url'].'/img/'.$cur_user['style'].'_new.png';
else
	$img_url = $pun_config['o_base_url'].'/img/'.$pun_config['o_default_style'].'_new.png';


$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_help['Help'];
require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead" colspan="2"><?php echo $lang_help['Help'] ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['BBCode'] ?></b>&nbsp;&nbsp;</td>
		<td class="puncon2">
			<div style="padding-left: 4px">
				<a name="bbcode"></a><?php echo $lang_help['BBCode info 1'] ?><br><br>
				<?php echo $lang_help['BBCode info 2'] ?><br><br>
			</div>
		</td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_help['Text style'] ?></b>&nbsp;&nbsp;</td>
		<td class="puncon2">
			<div style="padding-left: 4px">
				<?php echo $lang_help['Text style info'] ?><br><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[b]<?php echo $lang_help['Bold text'] ?>[/b] <?php echo $lang_help['produces'] ?> <b><?php echo $lang_help['Bold text'] ?></b><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[u]<?php echo $lang_help['Underlined text'] ?>[/u] <?php echo $lang_help['produces'] ?> <u><?php echo $lang_help['Underlined text'] ?></u><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[i]<?php echo $lang_help['Italic text'] ?>[/i] <?php echo $lang_help['produces'] ?> <i><?php echo $lang_help['Italic text'] ?></i><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[color=#FF0000]<?php echo $lang_help['Red text'] ?>[/color] <?php echo $lang_help['produces'] ?> <span style="color: #ff0000"><?php echo $lang_help['Red text'] ?></span><br><br>
			</div>
		</td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_help['Links and images'] ?></b>&nbsp;&nbsp;</td>
		<td class="puncon2">
			<div style="padding-left: 4px">
				<?php echo $lang_help['Links info'] ?><br><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[url=<?php echo $pun_config['o_base_url'].'/' ?>]<?php echo pun_htmlspecialchars($pun_config['o_board_title']) ?>[/url] <?php echo $lang_help['produces'] ?> <a href="<?php echo $pun_config['o_base_url'].'/' ?>"><?php echo pun_htmlspecialchars($pun_config['o_board_title']) ?></a><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[url]<?php echo $pun_config['o_base_url'].'/' ?>[/url] <?php echo $lang_help['produces'] ?> <a href="<?php echo $pun_config['o_base_url'] ?>"><?php echo $pun_config['o_base_url'].'/' ?></a><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[email]myname@mydomain.com[/email] <?php echo $lang_help['produces'] ?> <a href="mailto:myname@mydomain.com">myname@mydomain.com</a><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[email=myname@mydomain.com]<?php echo $lang_help['My e-mail address'] ?>[/email] <?php echo $lang_help['produces'] ?> <a href="mailto:myname@mydomain.com"><?php echo $lang_help['My e-mail address'] ?></a><br><br>
				<a name="img"></a><?php echo $lang_help['Images info'] ?><br><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[img]<?php echo $img_url ?>[/img] <?php echo $lang_help['produces'] ?> <img src="<?php echo $img_url ?>" border="0" align="top" alt=""><br><br>
			</div>
		</td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_help['Quotes'] ?></b>&nbsp;&nbsp;</td>
		<td class="puncon2">
			<div style="padding-left: 4px">
				<?php echo $lang_help['Quotes info'] ?><br><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[quote=James]<?php echo $lang_help['Quote text'] ?>[/quote]<br><br>
				<?php echo $lang_help['produces quote box'] ?><br><br>
				<table style="width: 95%" align="center" cellspacing="4" cellpadding="6"><tr><td class="punquote"><span class="puntext"><b>James <?php echo $lang_common['wrote'] ?>:</b><br><br><?php echo $lang_help['Quote text'] ?></span></td></tr></table><br>
				<?php echo $lang_help['Quotes info 2'] ?><br><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[quote]<?php echo $lang_help['Quote text'] ?>[/quote]<br><br>
				<?php echo $lang_help['produces quote box'] ?><br><br>
				<table style="width: 95%" align="center" cellspacing="4" cellpadding="6"><tr><td class="punquote"><span class="puntext"><?php echo $lang_help['Quote text'] ?></span></td></tr></table><br>
			</div>
		</td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_help['Code'] ?></b>&nbsp;&nbsp;</td>
		<td class="puncon2">
			<div style="padding-left: 4px">
				<?php echo $lang_help['Code info'] ?><br><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[code]<?php echo $lang_help['Code text'] ?>[/code]<br><br>
				<?php echo $lang_help['produces code box'] ?><br><br>
				<table style="width: 95%" align="center" cellspacing="4" cellpadding="6"><tr><td class="punquote"><span class="puntext"><b><?php echo $lang_common['Code'] ?>:</b></span><br><br><pre><?php echo $lang_help['Code text'] ?></pre></td></tr></table><br>
			</div>
		</td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_help['Nested tags'] ?></b>&nbsp;&nbsp;</td>
		<td class="puncon2">
			<div style="padding-left: 4px">
				<?php echo $lang_help['Nested tags info'] ?><br><br>
				&nbsp;&nbsp;&nbsp;&nbsp;[b][u]<?php echo $lang_help['Bold, underlined text'] ?>[/u][/b] <?php echo $lang_help['produces'] ?> <u><b><?php echo $lang_help['Bold, underlined text'] ?></b></u><br><br>
			</div>
		</td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['Smilies'] ?></b>&nbsp;&nbsp;</td>
		<td class="puncon2">
			<div style="padding-left: 4px">
				<a name="smilies"></a><?php echo $lang_help['Smilies info'] ?><br><br>
<?php

// Display the smiley set
require $pun_root.'include/parser.php';

$num_smilies = count($smiley_text);
for ($i = 0; $i < $num_smilies; ++$i)
{
	// Is there a smiley at the current index?
	if (!isset($smiley_text[$i]))
		continue;

	echo "\t\t\t\t".'&nbsp;&nbsp;&nbsp;&nbsp;'.$smiley_text[$i];

	// Save the current text and image
	$cur_img = $smiley_img[$i];
	$cur_text = $smiley_text[$i];

	// Loop through the rest of the array and see if there are any duplicate images
	// (more than one text representation for one image)
	for ($next = $i + 1; $next < $num_smilies; ++$next)
	{
		// Did we find a dupe?
		if ($smiley_img[$i] == $smiley_img[$next])
		{
			echo ' '.$lang_common['and'].' '.$smiley_text[$next];

			// Remove the dupe so we won't display it twice
			unset($smiley_text[$next]);
			unset($smiley_img[$next]);
		}
	}
	
	echo ' '.$lang_help['produces'].' <img src="img/smilies/'.$cur_img.'" width="15" height="15" alt="'.$cur_text.'"><br>'."\n";
}

?>
				<br>
			</div>
		</td>
	</tr>
</table>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

require $pun_root.'footer.php';
