<?php
/***********************************************************************

  Copyright (C) 2002, 2003, 2004  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


$pun_root = './';
require $pun_root.'include/common.php';


if ($cookie['is_guest'] && $pun_config['p_guests_read'] == '0')
	message($lang_common['Login required']);


// Load the userlist.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_userlist.php';

// Load the search.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_search.php';


// Determine if we are allowed to view post counts
$post_count = ($pun_config['o_show_post_count'] == '1' || $cur_user['status'] > PUN_USER) ? true : false;

$show_group = (!isset($_GET['show_group']) || intval($_GET['show_group']) < -1 && intval($_GET['show_group']) > 2) ? -1 : intval($_GET['show_group']);
$order_by = (!isset($_GET['order_by']) || $_GET['order_by'] != 'username' && $_GET['order_by'] != 'registered' && ($_GET['order_by'] != 'num_posts' || !$post_count)) ? 'username' : $_GET['order_by'];
$direction = (!isset($_GET['direction']) || $_GET['direction'] != 'asc' && $_GET['direction'] != 'desc') ? 'ASC' : strtoupper($_GET['direction']);


$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_common['User list'];
require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="get" action="userlist.php">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead"><?php echo $lang_common['User list'] ?></td>
		</tr>
		<tr>
			<td class="puncon2cent">
				<?php echo $lang_ul['Show group'] ?>&nbsp;&nbsp;<select name="show_group" tabindex="1">
					<option value="-1"<?php if ($show_group == -1) echo ' selected' ?>><?php echo $lang_ul['All users'] ?></option>
					<option value="<?php echo PUN_USER ?>"<?php if ($show_group == PUN_USER) echo ' selected' ?>><?php echo $lang_common['Member'] ?></option>
					<option value="<?php echo PUN_MOD ?>"<?php if ($show_group == PUN_MOD) echo ' selected' ?>><?php echo $lang_common['Moderator'] ?></option>
					<option value="<?php echo PUN_ADMIN ?>"<?php if ($show_group == PUN_ADMIN) echo ' selected' ?>><?php echo $lang_common['Administrator'] ?></option>
				</select>
				&nbsp;<?php echo $lang_ul['Order by'] ?>&nbsp;&nbsp;<select name="order_by" tabindex="2">
					<option value="username"<?php if ($order_by == 'username') echo ' selected' ?>><?php echo $lang_common['Username'] ?></option>
					<option value="registered"<?php if ($order_by == 'registered') echo ' selected' ?>><?php echo $lang_common['Registered'] ?></option>
<?php if ($post_count): ?>					<option value="num_posts"<?php if ($order_by == 'num_posts') echo ' selected' ?>><?php echo $lang_common['Posts'] ?></option>
<?php endif; ?>				</select>&nbsp;&nbsp;&nbsp;<select name="direction" tabindex="3">
					<option value="asc"<?php if ($direction == 'ASC') echo ' selected' ?>><?php echo $lang_search['Ascending'] ?></option>
					<option value="desc"<?php if ($direction == 'DESC') echo ' selected' ?>><?php echo $lang_search['Descending'] ?></option>
				</select>
				&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="<?php echo $lang_common['Submit'] ?>" tabindex="4" accesskey="s">
			</td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<?php


if ($post_count)
{
	$num_columns = 5;

?>
<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead" style="width: 28%"><?php echo $lang_common['Username'] ?></td>
		<td class="punhead" style="width: 30%"><?php echo $lang_common['Title'] ?></td>
		<td class="punhead" style="width: 24%"><?php echo $lang_common['Registered'] ?></td>
		<td class="punhead" style="width: 18%"><?php echo $lang_common['Posts'] ?></td>
	</tr>
<?php

}
else
{
	$num_columns = 4;

?>
<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead" style="width: 34%"><?php echo $lang_common['Username'] ?></td>
		<td class="punhead" style="width: 36%"><?php echo $lang_common['Title'] ?></td>
		<td class="punhead" style="width: 30%"><?php echo $lang_common['Registered'] ?></td>
	</tr>
<?php

}


// Fetch user count
$group_sql = ($show_group > -1) ? (($show_group == 0 ) ? ' WHERE status<1' : ' WHERE status='.$show_group) : '';
$result = $db->query('SELECT COUNT(id)-1 FROM '.$db->prefix.'users'.$group_sql) or error('Unable to fetch user list count', __FILE__, __LINE__, $db->error());
$num_users = $db->result($result, 0);


// Determine the user offset (based on $_GET['p'])
$num_pages = ceil($num_users / 50);

$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
$start_from = 50 * ($p - 1);


// Grab the users
$group_sql = ($show_group > -1) ? (($show_group == 0 ) ? ' AND status<1' : ' AND status='.$show_group) : '';
$result = $db->query('SELECT id, username, title, num_posts, status, registered FROM '.$db->prefix.'users WHERE id>1'.$group_sql.' ORDER BY '.$order_by.' '.$direction.' LIMIT '.$start_from.', 50') or error('Unable to fetch user list', __FILE__, __LINE__, $db->error());
$num_users_page = $db->num_rows($result);


if ($num_users_page)
{
	while ($num_users_page--)
	{
		$user_data = $db->fetch_assoc($result);

		$user_title_field = get_title($user_data);

?>
	<tr class="puncon2">
		<td><?php echo '<a href="profile.php?id='.$user_data['id'].'">'.pun_htmlspecialchars($user_data['username']).'</a>' ?></td>
		<td><?php echo $user_title_field ?></td>
		<td><?php echo format_time($user_data['registered'], true) ?></td>
<?php if ($post_count): ?>		<td><?php echo $user_data['num_posts'] ?></td>
<?php endif; ?>	</tr>
<?php

	}
}
else
	echo "\t".'<tr class="puncon2"><td colspan="'.$num_columns.'">'.$lang_ul['No users'].'</td></tr>'."\n";

?>
</table>

<table class="punspacer" cellspacing="1" cellpadding="4">
	<tr>
		<td><?php echo $lang_common['Pages'].': '.paginate($num_pages, $p, 'userlist.php?order_by='.$order_by.'&amp;direction='.strtolower($direction)) ?></td>
	</tr>
</table>
<?php

require $pun_root.'footer.php';
